/**
IMPLEMENTACIÓN DE ECOSISTEMA VIRTUAL "COOPERATE vs DEFECT"

Basado en:

- "El Dilema del Prisionero" (Teoría de Juegos) // http://prisonersdilemma.sergehelfrich.eu/
- Daniel Shiffman <http://www.shiffman.net> // Spring 2007, The Nature of Code.

------------------------------------

DESCRIPCIÓN:

1. La EVOLUCIÓN del ecosistema depende del estado de "SALUD" de los Agentes.
Este estado de "salud" se ve condicionado por la interacción entre los agentes,
y al mismo tiempo con el entorno:


  VALOR (+) "Salud" >> INTERACCIÓN ENTRE AGENTES  >> JUEGO (porcentaje variable según estrategia)
  VALOR (-) "Salud" >> INTERACCIÓN CON EL ENTORNO >> ENFERMEDAD (comer un rectangulo blanco)
  

2. La interacción entre agentes se da mediante el encuentro en el espacio,
momento en el que se inicializa el juego del "Dilema del Prisionero", donde cada agente adoptará una
estrategia predeterminada (Cooperar o Traicionar), obteniendo una puntuación según la matriz de pagos:

                           Jugador B
                         +-----------+-----------+
               Jugador A |  Cooperar |  Desertar |
             +-----------+-----------+-----------+
             |  Cooperar |   3 , 3   |  0 , 5    |
             +-----------+-----------+-----------+
             |  Desertar |   5 , 0   |  1 , 1    |
             +-----------+-----------+-----------+

Hemos implementado 4 posibles estrategias/Comportamiento:

*   Tipo 0: COOPERAR siempre; (rojo)
*   Tipo 1: DESERTAR siempre; (verde)
*   Tipo 2: SIGUE A LOS DEMÁS; (naranja) hacer lo que hizo la mayoría en la ronda anterior.
*   Tipo 3: OJO POR OJO; (azul): cooperar la primera vez, y en adelante hacer lo que
                        tu oponente hizo en la ronda anterior.

3.Existe un límite de iteraciones del juego, equivalente al "ciclo de vida" para cada agente.
Al mismo tiempo, cada agente dispone de un algoritmo genético, que mediante "mutación" otorga una probabilidad
de que su descendencia herede la estrategia de sus progenitores. El fenotipo influye además en
el tamaño y la velocidad de los agentes que son inversamente proporcionales.

4.El objetivo final del prototipo es visualizar en el ecosistema, aquellas
estrategias que mejor se adaptan y sobreviven en el tiempo.

------------------------------------
Diseño: Miguel Angel García Oliver // miguelgarciaoliver@gmail.com
Implementación Técnica: Jimena Quejigo
------------------------------------
*/

