

class Bloop {
  PVector location; // Localizacion
  PVector velocity;
 
  DNA dna;          // DNA
  float health;     // "salud"
  float xoff;       // perlin noise
  float yoff;
  
  // DNA determina: velocidad, tamaño, y estrategia de juego
  float r;
  float maxspeed;
  int comportamiento; //0 cooperan, 1 traicionan
  int tipo; //0 Siempre colaboran, 1 Siempre traicionan, 2 mayoria, 3 lo que le ha hecho el anterior.
  int njugadas;

  // Crear un agente
  Bloop(PVector l, DNA dna_) {
    location = l.get();
    velocity = new PVector(0,0);
    
    njugadas=0;
    health = 200;
    xoff = random(1000);
    yoff = random(1000);
    dna = dna_;
    maxspeed = map(dna.genes[0], 0, 1, 15, 0);
    r = map(dna.genes[0], 0, 2, 0, 40);
  
  }

  void run() {
    update();
    borders();
    display();
  }

  // Comer comida/veneno que resta salud
  void eat(Food f) {
    ArrayList<PVector> food = f.getFood();
    // comprobar colisión
    for (int i = food.size()-1; i >= 0; i--) {
      PVector foodLocation = food.get(i);
      float d = PVector.dist(location, foodLocation);
      if (d < r) {
        health -= 1.5; 
        food.remove(i);
      }
    }
  }

  // Reproducción //la descendencia es una copia exacta o existe posibilidad de mutación (tamaño, velocidad, estrategia)
  Bloop reproduce(float myhealth,int numbloops) {
    
    if ((myhealth > 210) && (myhealth < 600) && (random(1) < 0.005) && (numbloops<200)){
     
        
        DNA childDNA = dna.copy();
        
        childDNA.mutate(0.5);
        PVector locationAux= new PVector(location.x+r,location.y+r);
        return new Bloop(locationAux, childDNA);
      
    } 
    else if((numbloops<40)&&(numbloops>30)){ 
        DNA childDNA = dna.copy();
        // Child DNA can mutate
        childDNA.mutate(0.5);
        PVector locationAux= new PVector(location.x+r,location.y+r);
       
        return new Bloop(locationAux, childDNA);
        
    }
        
    else {
      return null;
    }
  }


  
  // Actualizar localización
 void update() {
   float angle = random(TWO_PI);
    //movimiento perlin noise
    float vx = map(noise(xoff),0,1,-maxspeed,maxspeed);
    float vy = map(noise(yoff),0,1,-maxspeed,maxspeed);
    PVector velocity = new PVector(vx,vy);
   
    xoff += 0.01;
    yoff += 0.01;
    location.add(velocity);
    
    // el desplazamiento resta salud
    health -= 0.2;
  }

  void borders() {
    if (location.x < -r) location.x = width+r;
    if (location.y < -r) location.y = height+r;
    if (location.x > width+r) location.x = -r;
    if (location.y > height+r) location.y = -r;
  }

   /* //////////////4 ESTRATEGIAS POSIBLES//////////////////////////
    
   Tipo 0: COOPERAR siempre; (rojo)
   Tipo 1: DESERTAR siempre; (verde)
   Tipo 2: SIGUE A LOS DEMÁS; (naranja)
   Tipo 3: OJO POR OJO; (azul)
    */
    
  void display() {
    World w;
    
    rectMode(CENTER);    
    if(dna.genes[1] < 0.25)
      {
        
        stroke(255,random(100),random(100),health);
        strokeWeight (1);
        //colaboran rojo
        fill(0,0);
        comportamiento=0;
        tipo=0;
      }
      
      if((dna.genes[1] >= 0.25) &&(dna.genes[1] < 0.5))
      {
        stroke(random(100),255,random(100),health);
        strokeWeight (1);
        fill(0,0);
        //traicionan verde
        comportamiento=1;
        tipo=1;
      }
      
      if((dna.genes[1] >= 0.5) &&(dna.genes[1] < 0.75))
      {
         stroke(245,165,5,health); //naranja
        strokeWeight (1);
        fill(0,0);
        //lo que hace la mayoria, se inicializa con random
        comportamiento=int(random(0,2));//es entre 0 y 2 porque trunca los valores
        tipo=2;
      }
      
      if((dna.genes[1] >= 0.75) &&(dna.genes[1] <= 1))
      {
        stroke(39,207,203,health); //Azul
        strokeWeight (1);
        fill(0,0);
       //lo que le ha hecho el ultimo. inicialmente colaboran
        comportamiento=0;
        tipo=3;
      }
    
    
    rect(location.x, location.y, r, r); 
    
  }

  //////////// Mueren cuando la salud es 0
  
  boolean dead() {
    if ((health < 0.0)) {
      return true;
    } 
    else {
      return false;
    }
  }
}

