

class World {

  ArrayList<Bloop> bloops;
  Food food;

  // Constructor
  World(int num) {
    
    food = new Food(int(random(num)));
    bloops = new ArrayList<Bloop>();
    for (int i = 0; i < num; i++) {
      PVector l = new PVector(random(width),random(height));
      DNA dna = new DNA();
      bloops.add(new Bloop(l,dna));
    }
  }

  // Nacimiento de agentes
  void born(float x, float y) {
    PVector l = new PVector(x,y);
    DNA dna = new DNA();
    bloops.add(new Bloop(l,dna));
  }

  // Correr el mundo
  void run() {
    food.run();
   
    
   
    for (int i = bloops.size()-1; i >= 0; i--) {
      // Los Agentes se mueven e interaccionan con el entorno
      Bloop b = bloops.get(i);
      b.run();
      b.eat(food);
      
      //Comprobamos si colisiona
     for (int j = bloops.size()-1; j >= 0; j--) {
        Bloop b1 = bloops.get(j);
        
        if(i!=j){
          
          float d = PVector.dist(b.location,b1.location);//Distancia entre 2 Agentes
          
          if ((d < b.r/3) || (d < b1.r/3)) { println("JUEGO1");Jugar(i,j);println("JUEGO2");} ////Si han colisionado jugaran
           }
        
      }
      
      // Si muere un agente, se elimina y se crea más comida/veneno
     if (b.dead()) {
        bloops.remove(i);
        food.add(b.location);
      }
      
      // Probabilidad de reproducirse
      Bloop child = b.reproduce(b.health,bloops.size());
      if (child != null) bloops.add(child);
   
  }
}

//////////JUEGO DEL DILEMA DEL PRISIONERO /////////////

  void Jugar(int i, int j)
  {
    Bloop b = bloops.get(i);
    Bloop b1 = bloops.get(j);
    
   //JUEGAN SI SU NUMERO DE PARTIDAS ES MENOR QUE 40
   //edad en la que se jubilan.//Esto da equilibrio al ecosistema.
   // CASOS POSIBLES: 
   
    if((b.njugadas<=40)||(b1.njugadas<=40)){
     //Los 2 colaboran
     if((b.comportamiento==0) && (b1.comportamiento==0))
        { 
          b.health += 3; b1.health +=3;//Actualizamos la salud
          ModificarComportamiento(i,j);           
          }
           
      //b colabora y b1 traiciona
      if((b.comportamiento==0) && (b1.comportamiento==1)) 
         {
           b.health += 0; b1.health +=4;//Actalizamos salud
           ModificarComportamiento(i,j);              
          }
            
        //Los b traiciona y b1 colabora
        if((b.comportamiento==1) && (b1.comportamiento==0)) 
           {
             b.health += 4; b1.health +=0;//Actualizamos salud
             ModificarComportamiento(i,j);
           }
            
        //Los 2 traicionan
        if((b.comportamiento==1) && (b1.comportamiento==1)) 
            {
              b.health += 1; b1.health +=1;//Actualizamos salud
              ModificarComportamiento(i,j);
            } 
             //incrementamos las jugadas
    b.njugadas++;
    b1.njugadas++;
  }//if((b.njugadas<=30)||(b1.njugadas<=30))    
         
  }

//Modifica el comportamiento de los bloops
  void ModificarComportamiento(int i, int j){
      //variable auxiliar para guardar el comportamiento, porque en el caso de que ambos agentes sean tipo 3 hay que guardar
       //en comportamiento del primero que se cambie para que luego lo tome el otro
       
     int AuxComportamiento; 
     boolean b1Cambio=false;
     Bloop b = bloops.get(i);
     Bloop b1 = bloops.get(j);
     
       if(b.tipo==2){ //comportamiento que adopta la mayoría 
             AuxComportamiento=b.comportamiento;
             b.comportamiento= mayoria();
             
             if(b1.tipo==2){b1.comportamiento=mayoria(); b1Cambio=true;}
             if(b1.tipo==3){ b1.comportamiento=AuxComportamiento; b1Cambio=true;}     
        }//if(b.tipo==2)
        
        if(b.tipo==3){
          AuxComportamiento=b1.comportamiento;
          
          if(b1.tipo==2){b1.comportamiento=mayoria();  b1Cambio=true;}
          if(b1.tipo==3){ b1.comportamiento=b.comportamiento; b1Cambio=true;}
        
          b.comportamiento=AuxComportamiento;  
        }
        
        if(b1Cambio==false){//Si b1 no ha cambiado
          if(b1.tipo==2){
            AuxComportamiento=b1.comportamiento;
            b1.comportamiento= mayoria();
            
            if(b.tipo==2){b.comportamiento=mayoria();}
            if(b.tipo==3){b.comportamiento=AuxComportamiento;}  
          }
          
          if(b1.tipo==3){ //comportamiento que adopta el anterior
               AuxComportamiento=b.comportamiento;  
               
               if(b.tipo==2){b.comportamiento=mayoria();}
               if(b.tipo==3){b.comportamiento=b1.comportamiento;}  
              
               b1.comportamiento=AuxComportamiento;   
          }//if(b1.tipo==3)
        }
    
}//void ModificarComportamiento(int i, int j)

 //Obtiene la mayoria de comportamientos de los agentes
 int mayoria()
    {
    int contCol=0; //Contador colaboración
    int contTra=0; // Contador traición
    
     for (int i = bloops.size()-1; i >= 0; i--) {
        Bloop b = bloops.get(i);
        if(b.comportamiento==0){contCol++;}
        else {contTra++;}
     }
     //Devolvemos la mayoria
     if (contCol>=contTra){return 0;}
     else {return 1;}
    }
    
 void imprimir(){
  int colaboran=0;
  int traicionan=0;
  int mayoria=0;
  int anterior=0;
  float salud=0.0;
  
  int colaborativos=0;
  int traidores=0;
  
  for (int i = bloops.size()-1; i >= 0; i--) {
    Bloop b = bloops.get(i);
    salud+=b.health;
    if(b.tipo==0){colaboran++;}
    if(b.tipo==1){traicionan++;}
    if(b.tipo==2){mayoria++;}
    if(b.tipo==3){anterior++;}
    
    if(b.comportamiento==0){colaborativos++;}
    if(b.comportamiento==1){traidores++;}
  }
  
  salud=salud/bloops.size();
   
  fill(255);
  
  text("Average health: " + salud, 20, 18);
  text("------------------",20, 36);
  noStroke();
  fill(255,0,0);
  rect(25,49,10,10);
  fill(255);
  text("Always cooperate: " + (colaboran*100)/bloops.size() +" %", 35, 54);
  noStroke();
  fill(0,255,0);
  rect(25,67,10,10);
  fill(255);
  text("Always defect: " + (traicionan*100)/bloops.size() +" %", 35, 72);
  noStroke();
  fill(245,165,5);
  rect(25,85,10,10);
  fill(255);
  text("Follow others: " + (mayoria*100)/bloops.size() +" %", 35, 90);
  noStroke();
  fill(39,207,203);
  rect(25,103,10,10);
  fill(255);
  text("Tit for Tat: " + (anterior*100)/bloops.size() +" %", 35,108);
  
   
 }
    
}//Termina la clase




